From 8b4ad65231e04a23ffb2a7a9b6d87a7c7c85b2fa Mon Sep 17 00:00:00 2001
From: anar <anar@localhost.localdomain>
Date: Oct 13 2017 12:13:13 +0000
Subject: [PATCH 983/1001] Changed the way validation occurs. Implemented GithubRepo and GithubOrg validators and their tests.


---

diff --git a/hubs/tests/test_widget_validators.py b/hubs/tests/test_widget_validators.py
index d421aa5..96d887f 100644
--- a/hubs/tests/test_widget_validators.py
+++ b/hubs/tests/test_widget_validators.py
@@ -30,7 +30,6 @@ class ValidatorsTest(APPTest):
         self.assertRaises(
             ValueError, validators.Username, "nobody")
 
-    @unittest.skip("Not implemented yet")
     def test_github_organization(self):
         self.assertEqual(
             validators.GithubOrganization("fedora-infra"),
@@ -40,12 +39,14 @@ class ValidatorsTest(APPTest):
             validators.GithubOrganization,
             "something-that-does-not-exist")
 
-    @unittest.skip("Not implemented yet")
     def test_github_repo(self):
         self.assertEqual(
-            validators.GithubRepo("fedmsg"), "fedmsg")
+            validators.GithubRepo('/'.join(["fedora-infra",
+                                            "fedmsg"])),
+            "fedmsg")
         self.assertRaises(ValueError, validators.GithubRepo,
-                          "something-that-does-not-exist")
+                          '/'.join(["fedora-infra",
+                                    "something-that-does-not-exist"]))
 
     def test_fmncontext(self):
         self.assertEqual(validators.FMNContext("email"), "email")
diff --git a/hubs/utils/github.py b/hubs/utils/github.py
index 47c1018..71ef257 100644
--- a/hubs/utils/github.py
+++ b/hubs/utils/github.py
@@ -9,6 +9,30 @@ import requests
 log = logging.getLogger(__name__)
 
 
+def github_org_is_valid(token, username):
+    log.info("Finding github organization for {}".format(username))
+    tmpl = "https://api.github.com/users/{username}"
+    url = tmpl.format(username=username)
+    auth = dict(access_token=token)
+    result = requests.get(url, params=auth)
+    if not bool(result):
+        return False
+    else:
+        return True
+
+
+def github_repo_is_valid(token, username, repo):
+    log.info("Finding github repo for {} and {} ".format(repo, username))
+    tmpl = "https://api.github.com/repos/{username}/{repo}"
+    url = tmpl.format(username=username, repo=repo)
+    auth = dict(access_token=token)
+    result = requests.get(url, params=auth)
+    if not bool(result):
+        return False
+    else:
+        return True
+
+
 def github_repos(token, username):
     log.info("Finding github repos for %r" % username)
     tmpl = "https://api.github.com/users/{username}/repos?per_page=100"
diff --git a/hubs/utils/views.py b/hubs/utils/views.py
index 2508dad..5e7581b 100644
--- a/hubs/utils/views.py
+++ b/hubs/utils/views.py
@@ -118,16 +118,17 @@ def configure_widget_instance(widget_instance, widget_config):
     """
     if not widget_config:
         return
-    config = {}
+    vals = {}
     for param in widget_instance.module.get_parameters():
         val = widget_config.get(param.name)
         if not val:
             raise WidgetConfigError(
                 'You must provide a value for: %s' % param.name)
-        try:
-            config[param.name] = param.validator(val)
-        except ValueError as err:
-            raise WidgetConfigError('Invalid data provided, error: %s' % err)
+        vals[param.name] = val
+    try:
+        config = widget_instance.module.validate_parameters(vals)
+    except ValueError as err:
+        raise WidgetConfigError('Invalid data provided, error: %s' % err)
     # Updating in-place is not supported, it's a class property.
     cur_config = widget_instance.config or {}
     cur_config = cur_config.copy()
diff --git a/hubs/widgets/base.py b/hubs/widgets/base.py
index db63192..42a1965 100644
--- a/hubs/widgets/base.py
+++ b/hubs/widgets/base.py
@@ -99,7 +99,15 @@ class Widget(object):
             # Try to be smart-ish with the default label.
             self.label = self.name.replace("_", " ").replace(".", ": ").title()
         self._template_environment = None
+#
 
+    def validate_parameters(self, vals):
+        config = {}
+        for param in self.get_parameters():
+            config[param.name] = param.validator(vals[param.name])
+        return config
+
+#
     def validate(self):
         """
         Ensure that the widget has the bits it needs.
diff --git a/hubs/widgets/githubissues/__init__.py b/hubs/widgets/githubissues/__init__.py
index fa0c996..8334c23 100644
--- a/hubs/widgets/githubissues/__init__.py
+++ b/hubs/widgets/githubissues/__init__.py
@@ -34,6 +34,17 @@ class GitHubIssues(Widget):
             help="The number of tickets to display.",
         )]
 
+    def validate_parameters(self, vals):
+        config = {}
+        config["org"] = \
+            validators.GithubOrganization(vals["org"])
+        config["repo"] = \
+            validators.GithubRepo('/'.join([vals["org"],
+                                           vals["repo"]]))
+        config["display_number"] = \
+            validators.Integer(vals["display_number"])
+        return config
+
 
 class BaseView(RootWidgetView):
 
diff --git a/hubs/widgets/validators.py b/hubs/widgets/validators.py
index f8c5b8f..75257ba 100644
--- a/hubs/widgets/validators.py
+++ b/hubs/widgets/validators.py
@@ -10,6 +10,8 @@ will return the validated value.
 """
 
 from __future__ import unicode_literals
+from hubs.utils.github import github_org_is_valid, github_repo_is_valid
+from hubs.utils import get_fedmsg_config
 
 import flask
 import hubs.models
@@ -17,6 +19,8 @@ import kitchen.text.converters
 import requests
 import six
 
+fedmsg_config = get_fedmsg_config()
+
 
 def Required(value):
     """Raises an error if the value is ``False``-like."""
@@ -61,14 +65,19 @@ def Username(value):
 
 def GithubOrganization(value):
     """Fails if the Github organization name does not exist."""
-    # TODO -- implement this.
+    token = fedmsg_config.get('github.oauth_token')
+    if not github_org_is_valid(token, value):
+        raise ValueError('Github organization does not exist')
     return value
 
 
 def GithubRepo(value):
     """Fails if the Github repository name does not exist."""
-    # TODO -- implement this.
-    return value
+    token = fedmsg_config.get('github.oauth_token')
+    username, repo = value.split('/')
+    if not github_repo_is_valid(token, username, repo):
+        raise ValueError('Github repository does not exist')
+    return repo
 
 
 def FMNContext(value):

